Bug 451286 - Better window placement
Better window placement
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: metacity (Show other bugs)
11
All Linux
low Severity medium
: ---
: ---
Assigned To: Søren Sandmann Pedersen
Fedora Extras Quality Assurance
http://bugzilla.gnome.org/show_bug.cg...
: Regression
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2008-06-13 14:00 EDT by Stefan Plewako
Modified: 2014-06-18 05:10 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-16 11:38:47 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
RPM diff to backport window cascading fix from upstream (2.71 KB, patch)
2008-09-03 18:29 EDT, Dan Nicholson
no flags Details | Diff
Restore cascading of non-placed windows (880 bytes, patch)
2008-10-23 12:33 EDT, Dan Nicholson
no flags Details | Diff

  None (edit)
Description Stefan Plewako 2008-06-13 14:00:20 EDT
Description of problem: if there is some window already on current workspace,
gnome/metacity will open every next window exactly on the upper left corner.
This is really bad. New windows should be opened on a free space if possible
(not over existing ones) and if this is impossible they should be placed in
cascade, close to center of the screen.


Version-Release number of selected component (if applicable): current from f9
How reproducible: always
Steps to Reproduce:
1. log in to gnome
2. open gnome terminal
3. open next window
  
Actual results: every next window will appear exactly on the upper left corner
Expected results: smart window placement using free space and when it is
impossible, centered windows. (or any equivalent)
Comment 1 Dmitry Butskoy 2008-08-15 08:40:54 EDT
This issue is already confirmed and fixed in upstream, see
http://bugzilla.gnome.org/show_bug.cgi?id=529925

Please, backport this fixes for F8 and F9, because the current behaviour is really annoying...
Comment 2 Stefan Plewako 2008-08-15 11:32:34 EDT
Don't know if I read this correctly but this only fixes one part of reported problem - it ads cascade feature but start window placement position would be still at top right corner.
Comment 3 Dmitry Butskoy 2008-08-15 13:09:31 EDT
Yes. 

It seems that the upstream's decision is to return back the "cascade" feature, but not return "random" placement (disappeared long time ago afaik...)

The promotion of some another useful placement method (ie. random) is suitable at upstream (they should implement something). But now, it is possible and useful to return back at least the "cascade" method. IMHO, just by creating a patch by the cvs commit mentioned in the upstream bugzilla ticket.
Comment 4 Dan Nicholson 2008-09-03 18:29:19 EDT
Created attachment 315704 [details]
RPM diff to backport window cascading fix from upstream

The patch embedded in this RPM diff restores the window cascading. I've tested this on F-9 and it works as metacity always did. Please consider applying.
Comment 5 Dan Nicholson 2008-10-23 12:33:11 EDT
Created attachment 321314 [details]
Restore cascading of non-placed windows

Here's just the patch this time from upstream applied to metacity-2.22.0. Here's a scratch build on koji if you want to test it:

http://koji.fedoraproject.org/koji/taskinfo?taskID=898357
Comment 6 Stefan Plewako 2008-10-23 13:40:58 EDT
The package works quite well as far as I can tell (thanks!) but it only fixes the cascade regression and this was not the biggest problem here, however it's a step in good direction.

What we are still missing is better start point (still exactly left corner) and better cascade (calculation?). With patch applied the second window is placed at the corner and then every next will be shifted down and right with window titlebar height and border width so, following ux problems are still present:

1. The upper left corner for the second window - this should be centered or free space.

2. Cascade step is too small; when one have three windows in such cascade and then brings the first one to up to front, there is no easy "clicky" way to activate the second (last one/third have some visible space on the bottom, but not second) - this could be fixed by horizontal shift (eg one step == ~2x window controls width), bigger (~2.5times) vertical shift could be useful too.

3. There is much desktop space wasted and big concentration (more clicking) in the corner - the optimal solution would open windows on a "free space" if they fit and when not, it would start 4direction cascade (not from corner but from active window): first shift: right&bottom, second top&left, third top&right, fourth left&bottom, fifth with increased shift factor right&bottom and so on.
Comment 7 markm 2008-12-01 12:42:46 EST
it would be great if new window on the empty workspace was open centred, not in the top left corner... some applications would still open in the centre - i.e. browsing video clips using nautilus would open a new video in the centre - user probably wants to see this video and doesn't care about other apps for a while. Cascade or placing windows in the top left corner is not intuitive and forces users to move the window.
Comment 8 Bug Zapper 2009-06-09 21:35:41 EDT
This message is a reminder that Fedora 9 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 9.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '9'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 9's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 9 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 9 Owen Taylor 2009-11-16 11:38:47 EST
The cascade bug is OK in current releases; we're not going to deviate from upstream and introduce new options for window placement.

Note You need to log in before you can comment on or make changes to this bug.